require "import"
import "android.widget.*"
import "com.androlua.*"
import "android.view.View"
import "android.os.Environment"
import "java.io.File"
import "java.net.URL"
import "java.io.FileOutputStream"
import "android.app.DownloadManager"
import "android.net.Uri"
import "android.content.Context"
import "android.text.Html"
import "cjson"

-- YOUR HUGGING FACE ACCESS TOKEN
local API_TOKEN = "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"  -- **Replace with your actual token!**

-- Function to interact with Hugging Face Inference API
function query(data, callback)
  local apiUrl = "https://api-inference.huggingface.co/models/bigcode/starcoder"

  local requestBody = cjson.encode(data)

  local headers = {}
  headers["Authorization"] = "Bearer " .. API_TOKEN
  headers["Content-Type"] = "application/json"

  Http.post(apiUrl, requestBody, headers, function(code, content)
    if code == 200 then
      local success, result = pcall(cjson.decode, content)
      if success then
        callback(cjson.encode(result), nil) -- Return the full JSON response
      else
        callback(nil, "Error decoding JSON response: " .. content)
      end
    else
      callback(nil, "Error querying Hugging Face API. Status code: " .. code .. ", Content: " .. content)
    end
  end)
end

-- Create main layout
layout = {
  LinearLayout,
  orientation = "vertical",
  layout_width = "fill",
  layout_height = "fill",
  padding = "16dp",
  {
    EditText,
    id = "inputText",
    hint = "Enter your input for starcoder",
    layout_width = "fill",
    layout_height = "wrap_content",
    padding = "10dp",
  },
  {
    Button,
    id = "queryButton",
    text = "Query Hugging Face API",
    layout_width = "fill",
    layout_height = "wrap_content",
  },
  {
    TextView,
    id = "resultText",
    text = "",
    layout_width = "fill",
    layout_height = "wrap_content",
    padding = "10dp",
  },
  { -- Added LinearLayout for Exit button and Credit text
    LinearLayout,
    orientation = "vertical",
    layout_width = "fill",
    layout_height = "wrap_content",
    {
      Button,
      id = "exitButton",
      text = "Exit",
      layout_width = "wrap_content",
      layout_height = "wrap_content",
    },
    {
      TextView,
      text = "Join our channel for more content:\nhttps://t.me/jcftbs",
      layout_width = "fill",
      layout_height = "wrap_content",
      gravity = "center",
      padding = "5dp",
    }
  }
}

-- Create dialog
dlg = LuaDialog(this)
dlg.setTitle("starcoder")
dlg.setView(loadlayout(layout))

-- Function to update result text (MODIFIED to show only AI response)
function updateResultText(result)
  local success, decoded_result = pcall(cjson.decode, result)
  if success then
    -- Assuming the AI response is always in the first element of the array
    if decoded_result[1] and decoded_result[1].generated_text then
      resultText.text = decoded_result[1].generated_text
    else
      resultText.text = "Error: Unexpected JSON format"
    end
  else
    resultText.text = "Error decoding JSON: " .. result
  end
end

-- Set up query button
queryButton.onClick = function()
  local input = inputText.text

  if input and #input > 0 then
    updateResultText("Querying Hugging Face API...")

    query({ inputs = input }, function(result, error)
      if error then
        updateResultText("Error: " .. error)
      else
        updateResultText(result) -- Display the AI response only
      end
    end)
  else
    updateResultText("Please enter input for starcoder")
  end
end

-- Set up exit button
exitButton.onClick = function()
  dlg.dismiss()
end

-- Show dialog
dlg.show()